/* JavaScript Shared/Common for all BigMike's Guide to Snowboarding Pages */

/*
Variables
 */

var isMobile = false; //initiate as false
var navOverflow = false; //initiate as false
var navDisplayed = true; // True or flase, are nav buttons displayed?

// Iteration to update CSS Display for all element of a class.
function displayByClass(element, cssValue) { 
    var i;
    for (i = 0; i < element.length; i++) {
        element[i].style.display = cssValue;
    }
}

/*
Function to set stylesheet
Based on scripts from the following Stack Overflow Post by multiple users: https://stackoverflow.com/questions/19844545/replacing-css-file-on-the-fly-and-apply-the-new-style-to-the-page
*/   
    
function setStyleSheet(url){
    var stylesheet = document.getElementById("stylesheet");
    stylesheet.setAttribute('href', url);
} 


/* 
Detect Mobile Devices
Based on scripts from the following Stack Overflow Post edited by multiple users: https://stackoverflow.com/questions/3514784/what-is-the-best-way-to-detect-a-mobile-device/3540295#3540295
*/

// If following keywords are found in userAgent, set device as mobile
if (/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)) {
    isMobile = true;
    setStyleSheet('css/mobile.css');
}
 
// Function to toggle nav buttons if dropdown menu is displayed.
function toggleNavButtons() {
    var nc = document.getElementById('nav-buttons-container');
    var nb = document.getElementsByClassName("nav-button");
    /*function cssDisplay(cssValue) {
        nc.style.display = cssValue;
        for (i = 0; i < nb.length; i++) {
            nb[i].style.display = cssValue;
        }
    }*/
    if (nc.style.display === 'block') {
        nc.style.display = 'none';
        displayByClass(nb, 'none');
    } else {
        nc.style.display = 'block';
        displayByClass(nb, 'block');
    }
}
    
/*
Dropdown script and menu above is based on W3schools example: https://www.w3schools.com/howto/howto_js_mobile_navbar.asp
*/

function dropdownMenu() {

    // Set Common Variables
    var navbarWidth = document.getElementById("nav-bar").scrollWidth;
    var buttonsTotalWidth = 15; // Initiated with a safety buffer for margins
    var nc = document.getElementById('nav-buttons-container');
    var nb = document.getElementsByClassName("nav-button");

    // Function to calculate the total width of all buttons
    // Script based on: https://stackoverflow.com/questions/7138772/how-to-detect-overflow-in-div-element

    function calcButtonWidth () {
        var i;
        for (i = 0; i < nb.length; i++) {
            buttonsTotalWidth += nb[i].scrollWidth;
        }
    }

    // Function to Switch between inline-block menu and dropdown menu.
    function changeMenu(dropdown) { // Dropdown True = Dropdown Menu, Dropdown Flase = Inline-Block Menu
        var fafa = document.getElementById("fafa-span");
        if (dropdown) { // If dropdown = true
            fafa.style.display = 'block';
            nc.style.display = 'none';
            nb[0].style.marginLeft = '0px';
            displayByClass(nb, 'none');
            navDisplayed = false;
        } else { // if dropdown = false
            fafa.style.display = 'none';
            nc.style.display = 'inline-block';
            nb[0].style.marginLeft = '5px';
            displayByClass(nb, 'inline-block');
            navDisplayed = true;
        }
    }
    
    // Call function to calculate total width of nav buttons.
    if (navDisplayed) { // Call calc right away if buttons are displayed.
        calcButtonWidth();
    } else { // If buttons are hidden, must display to calc new width and hide them again. Cannot calculate width on hidden buttons.
        nc.style.display = 'block';
        displayByClass(nb, 'block');
        calcButtonWidth();
        nc.style.display = 'none';
        displayByClass(nb, 'none');
    }

    // Switch From Inline to Dropdown and Vice Versa
    if (navOverflow != (buttonsTotalWidth > navbarWidth)) { // Proceed only if a change in menu is required
        if (buttonsTotalWidth > navbarWidth) { // Change to dropdown menu
            changeMenu(true); // True = Dropdown menu
            navOverflow = true;
        } else { // Change to inline-block desktop menu
            changeMenu(false); // False = Inline-block menu
            navOverflow = false;
        }
    }
     
}

// Collapsible Section Toggle
function collapseSection(name) {
    var section = document.getElementById(name);
    if (section.style.display === 'block') {
        section.style.display = 'none';
    } else {
        section.style.display = 'block';
    }

}

// Expand / Collapse All Sections
function expandAll(expand) {
    var collapsible = document.getElementsByClassName("collapsible");
    if (expand) { // If expand is true, expand all sections.
        displayByClass(collapsible, 'block');
    } else { // If expand is false, collapse all sections.
        displayByClass(collapsible, 'none');
    }

}

// Scale Image (Only if Mobile Device)
function scaleImage(imgId, imgWidth) {
    if (isMobile) { 
        var img = document.getElementById(imgId);
        img.style.width = imgWidth;
        img.style.height = 'auto';
    }
}
